/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ExternalEventWorkItem$1 } from "./ExternalEventWorkItem$1";
import { ExternalEventWorkItem } from "./ExternalEventWorkItem";
import { BaseError, Base, Stream, typeCast, fromEnum, markType } from "igniteui-angular-core";
import { IZipFile_$type } from "./IZipFile";
import { List$1 } from "igniteui-angular-core";
import { IZipEntry_$type } from "./IZipEntry";
import { ZipEntry } from "./ZipEntry";
import { MemoryStream } from "igniteui-angular-core";
import { b64toUint8Array } from "igniteui-angular-core";
import * as JSZip from "jszip/dist/jszip";
/**
 * @hidden
 */
export class ZipFile extends Base {
    constructor() {
        super();
        this.a = new List$1(IZipEntry_$type, 0);
        this.b = null;
        this.b = typeof JSZip.default === "function" ? new JSZip.default() : new JSZip();
    }
    createFile(fileName, directoryName, stream) {
        arguments[2] = (typeof arguments[2] === 'string' ? b64toUint8Array(arguments[2]) : arguments[2]);
        arguments[2] = (typeCast(Stream.$, arguments[2]) ? arguments[2] : new MemoryStream(2, arguments[2]));
        return this._createFile$i.apply(this, arguments);
    }
    _createFile$i(a, b, c) {
        return ZipEntry.a(a, b, c);
    }
    load(stream) {
        arguments[0] = (typeof arguments[0] === 'string' ? b64toUint8Array(arguments[0]) : arguments[0]);
        arguments[0] = (typeCast(Stream.$, arguments[0]) ? arguments[0] : new MemoryStream(2, arguments[0]));
        return this._load$i.apply(this, arguments);
    }
    _load$i(a) {
        let b = null;
        let c = typeCast(MemoryStream.$, a);
        if (c != null) {
            b = c.getBuffer();
            if (b.length != a.length) {
                b = null;
            }
        }
        if (b == null) {
            b = new Array(a.length);
            a.read(b, 0, b.length);
        }
        let d = new ExternalEventWorkItem$1(IZipFile_$type);
        let e = (f) => {
            let g = (Base.getArrayOfValues(this.b.files));
            for (let h = 0; h < g.length; h++) {
                this.a.add(new ZipEntry(0, g[h]));
            }
            d.ag(this);
        };
        let f = (g) => d.ag(null, new BaseError(1, g != null ? g.toString() : "Load error"));
        this.b.loadAsync(b).then(e, f);
        return d;
    }
    get entries() {
        return this.a;
    }
    save(stream) {
        arguments[0] = (typeof arguments[0] === 'string' ? b64toUint8Array(arguments[0]) : arguments[0]);
        arguments[0] = (typeCast(Stream.$, arguments[0]) ? arguments[0] : new MemoryStream(2, arguments[0]));
        return this._save$i.apply(this, arguments);
    }
    _save$i(a) {
        for (let b of fromEnum(this.a)) {
            let c = b;
            let d = c.name;
            if (d.charAt(0) == '/') {
                d = d.substr(1);
            }
            if (c.isDirectory) {
                this.b.folder(d);
            }
            else {
                let e = new Array(c.b.length);
                c.b.position = 0;
                c.b.read(e, 0, e.length);
                this.b.file(d, e);
            }
        }
        let f = (JSZip.support.uint8array) ? "uint8array" : "array";
        let g = new ExternalEventWorkItem();
        let h = (i) => {
            let j = i;
            a.write(j, 0, j.length);
            g.af();
        };
        let i = (j) => g.af(new BaseError(1, j != null ? j.toString() : "Load error"));
        this.b.generateAsync({ type: f, compression: 'DEFLATE' }).then(h, i);
        return g;
    }
}
ZipFile.$t = markType(ZipFile, 'ZipFile', Base.$, [IZipFile_$type]);
//# sourceMappingURL=ZipFile.js.map